{% extends "base.html" %}

{% block content %}
    {% if ra_config %}
        {% if not user %}
            <div class="row">
                <div class="col-6">
                    <form class="text-center border border-light p-5" action="" method="post">
                        {{ form.hidden_tag() }}
                        <p class="h4 mb-4">{{ title }}</p>

                        <hr>
                        <p class="h5 mb-5">User</p>
                        <p class="h6 mb-6">Please enter the users which you want to enable with remote access</p>

                        <!-- Add Remote Access User: Username -->
                        <div class="form-group text-left">
                            <label for="{{ form.username.id }}">Username</label>
                            {% if form.username.errors %}
                                {{ form.username(size=15, class="form-control is-invalid", placeholder="Username") }}
                                <div class="invalid-feedback">{{ form.username.errors[0] }}</div>
                            {% else %}
                                {{ form.username(size=15, class="form-control", placeholder="Username") }}
                            {% endif %}
                        </div>

                        <!-- Add Remote Access User: First name -->
                        <div class="form-group text-left">
                            <label for="{{ form.firstname.id }}">Firstname</label>
                            {% if form.firstname.errors %}
                                {{ form.firstname(size=15, class="form-control is-invalid", placeholder="First name") }}
                                <div class="invalid-feedback">{{ form.firstname.errors[0] }}</div>
                            {% else %}
                                {{ form.firstname(size=15, class="form-control", placeholder="First name") }}
                            {% endif %}
                        </div>

                        <!-- Add Remote Access User: Surname -->
                        <div class="form-group text-left">
                            <label for="{{ form.surname.id }}">Surname</label>
                            {% if form.surname.errors %}
                                {{ form.surname(size=15, class="form-control is-invalid", placeholder="Surname") }}
                                <div class="invalid-feedback">{{ form.surname.errors[0] }}</div>
                            {% else %}
                                {{ form.surname(size=15, class="form-control", placeholder="Surname") }}
                            {% endif %}
                        </div>

                        <!-- Tunnel IP + Mask (CIDR) -->
                        <div class="form-group text-left">
                            <label for="{{ form.tunnel_cidr.id }}">Tunnel IP / Prefix</label>
                            {% if form.tunnel_cidr.errors %}
                                {{ form.tunnel_cidr(class="form-control is-invalid", placeholder="Tunnel IP: 172.16.254.2/24") }}
                                <div class="invalid-feedback">{{ form.tunnel_cidr.errors[0] }}</div>
                            {% else %}
                                {{ form.tunnel_cidr(class="form-control", placeholder="Tunnel IP: 172.16.254.11/24") }}
                            {% endif %}
                        </div>

                        <!-- WiFi Subnet (CIDR) -->
                        {% if ra_config.l3 %}
                            <div class="form-group text-left">
                                <label for="{{ form.wifi_cidr.id }}">WiFi Default Gateway / Prefix</label>
                                {% if form.wifi_cidr.errors %}
                                    {{ form.wifi_cidr(class="form-control is-invalid", id="wifi_cidr", placeholder="WiFi Router IP + Mask: 192.168.4.1/24") }}
                                    <div class="invalid-feedback">{{ form.wifi_cidr.errors[0] }}</div>
                                {% else %}
                                    {{ form.wifi_cidr(class="form-control", id="wifi_cidr", placeholder="WiFi Router IP + Mask: 192.168.4.1/24") }}
                                {% endif %}
                            </div>
                        {% endif %}

                        <!-- Options -->
                        <hr>
                        <p class="h5 mb-5">Options</p>

                        <!-- PSK -->
                        <div class="form-check text-left">
                            {{ form.use_psk(class="form-check-input") }}
                            <label class="form-check-label" for="{{ form.use_psk.id }}">Generate and use a pre-shared
                                key?</label>
                        </div>

                        <!-- Keepalive -->
                        {% if form.keepalive.errors %}
                            <div class="form-check text-left mt-4">
                                <label class="form-check-label">Keepalive in seconds: </label>
                                {{ form.keepalive(class="form-control is-invalid", placeholder="0 - 65535") }}
                            </div>
                            <div class="invalid-feedback">
                                {{ form.keepalive.errors[0] }}
                            </div>
                        {% else %}
                            <div class="form-text text-left mt-4">
                                <label class="form-text-label">Keepalive in seconds: </label>
                                {{ form.keepalive(class="form-control", placeholder="0 - 65535") }}
                            </div>
                        {% endif %}



                        <hr>
                        <!-- Send button -->
                        {{ form.submit(class="btn btn-primary btn-block") }}

                    </form>
                </div>
            </div>
        {% else %}
            <div class="row">
                <div class="col-6">
                    <form class="text-center border border-light p-5" action="" method="post">
                        {{ form.hidden_tag() }}
                        <p class="h4 mb-4">{{ title }}</p>

                        <hr>
                        <p class="h5 mb-5">User</p>
                        <p class="h6 mb-6">Please enter the users which you want to enable with remote access</p>

                        <!-- Add Remote Access User: Username -->
                        <div class="form-group text-left">
                            <label for="{{ form.username.id }}">Username</label>
                            {% if form.username.errors %}
                                {{ form.username(size=15, class="form-control is-invalid", placeholder="Username", value=user.username or '') }}
                                <div class="invalid-feedback">{{ form.username.errors[0] }}</div>
                            {% else %}
                                {{ form.username(size=15, class="form-control", placeholder="Username", value=user.username or '') }}
                            {% endif %}
                        </div>

                        <!-- Add Remote Access User: First name -->
                        <div class="form-group text-left">
                            <label for="{{ form.firstname.id }}">Firstname</label>
                            {% if form.firstname.errors %}
                                {{ form.firstname(size=15, class="form-control is-invalid", placeholder="First name", value=user.firstname or '') }}
                                <div class="invalid-feedback">{{ form.firstname.errors[0] }}</div>
                            {% else %}
                                {{ form.firstname(size=15, class="form-control", placeholder="First name", value=user.firstname or '') }}
                            {% endif %}
                        </div>

                        <!-- Add Remote Access User: Surname -->
                        <div class="form-group text-left">
                            <label for="{{ form.surname.id }}">Surname</label>
                            {% if form.surname.errors %}
                                {{ form.surname(size=15, class="form-control is-invalid", placeholder="Surname", value=user.surname or '') }}
                                <div class="invalid-feedback">{{ form.surname.errors[0] }}</div>
                            {% else %}
                                {{ form.surname(size=15, class="form-control", placeholder="Surname", value=user.surname or '') }}
                            {% endif %}
                        </div>

                        <!-- B Tunnel IP + Mask (CIDR) -->
                        <div class="form-group text-left">
                            <label for="{{ form.tunnel_cidr.id }}">Tunnel IP</label>
                            {% if form.tunnel_cidr.errors %}
                                {{ form.tunnel_cidr(class="form-control is-invalid", placeholder="Tunnel IP: 172.16.254.2/24", value=user.tunnel_cidr or '') }}
                                <div class="invalid-feedback">{{ form.tunnel_cidr.errors[0] }}</div>
                            {% else %}
                                {{ form.tunnel_cidr(class="form-control", placeholder="Tunnel IP: 172.16.254.11/24", value=user.tunnel_cidr or '') }}
                            {% endif %}
                        </div>

                        <!-- WiFi Subnet (CIDR) -->
                        {% if ra_config.l3 %}
                            <div class="form-group text-left">
                                <label for="{{ form.wifi_cidr.id }}">WiFi Network</label>
                                {% if form.wifi_cidr.errors %}
                                    {{ form.wifi_cidr(class="form-control is-invalid", id="wifi_cidr", placeholder="WiFi Router IP + Mask: 192.168.4.1/24", value=user.wifi_cidr or '') }}
                                    <div class="invalid-feedback">{{ form.wifi_cidr.errors[0] }}</div>
                                {% else %}
                                    {{ form.wifi_cidr(class="form-control", id="wifi_cidr", placeholder="WiFi Router IP + Mask: 192.168.4.1/24", value=user.wifi_cidr or '') }}
                                {% endif %}
                            </div>
                        {% endif %}

                        <!-- Options -->
                        <hr>
                        <p class="h5 mb-5">Options</p>

                        <!-- PSK -->
                        {% if user.psk %}
                            <div class="form-check text-left">
                                {{ form.use_psk(class="form-check-input", checked="") }}
                                <label class="form-check-label" for="{{ form.use_psk.id }}">Generate and use a
                                    pre-shared
                                    key?</label>
                            </div>
                        {% else %}
                            <div class="form-check text-left">
                                {{ form.use_psk(class="form-check-input") }}
                                <label class="form-check-label" for="{{ form.use_psk.id }}">Generate and use a
                                    pre-shared
                                    key?</label>
                            </div>
                        {% endif %}

                        <!-- Keepalive -->
                        {% if form.keepalive.errors %}
                            <div class="form-check text-left">
                                <label class="form-check-label">Keepalive in seconds: </label>
                                {{ form.keepalive(class="form-control is-invalid", placeholder="0 - 65535", value=user.keepalive or '') }}
                            </div>
                            <div class="invalid-feedback">
                                {{ form.keepalive.errors[0] }}
                            </div>
                        {% else %}
                            <div class="form-text text-left mt-4">
                                <label class="form-text-label">Keepalive in seconds: </label>
                                {{ form.keepalive(class="form-control", placeholder="0 - 65535", value=user.keepalive or '') }}
                            </div>
                        {% endif %}



                        <hr>
                        <!-- Send button -->
                        {{ form.submit(class="btn btn-primary btn-block", value="Update User") }}

                    </form>
                </div>
            </div>

        {% endif %}
    {% elif not ra_config %}
        <div class="alert alert-warning">
            <p>Please first configure the Remote-Access Server.</p>
            <a class="navbar-brand mr-1" href="{{ url_for("url.setup_ra") }}">
                <button class="btn btn-primary btn-block">
                    <i class="fas fa-fw fa-server"></i>
                    Setup Server for Remote Acesss
                </button>
            </a>
            <p>There was no Remote Access configuration done yet!</p>
        </div>
    {% endif %}
{% endblock %}